<template lang="pug">

mixin HeaderSortIcon
  i.mr-2.mt-1.header-icon.fa&attributes(attributes)

.col-12
  .row.mt-2.d-flex.align-items-center(v-if='showControls')
    .col-12.col-sm-12.col-lg-4.form-group.form-inline.justify-content-left
      //- Page Selector
      span.text-nowrap
        label Entries:
          BaseSelect.ml-2(v-model.number='pageSize' :inEdit='true' :noEditIcon='true')
            template(v-slot:options='')
              option(:value='10') 10
              option(:value='25') 25
              option(:value='50') 50
              option(:value='100') 100
    .col-12.col-sm-12.col-lg-8.form-group(v-show="filesCount > 0")
      //- Pagination Bar
      PaginationBar(:currentPage="currentPage" :totalRows="filesCount" :perPage="pageSize" @change-page="changePage($event)")
  .row.mt-2.d-flex.align-items-center
    .col-12.mt-1
      //- Spinner while data is loading
      BaseModalLoader(:isLoading="fileLoading")
      table.table.table-sm.table-hover
        thead
          //- Header for Large Screen
          template(v-if="isScreenLG")
            tr.table-head
              //- first  th is for collapsible icon
              th.clickable.w-25(scope='col' @click="setSorting('index')") File Name
                +HeaderSortIcon()(:class="getSortingClass('index')")
              th.clickable(scope='col' @click="setSorting('status')") Status
                +HeaderSortIcon()(:class="getSortingClass('status')")
              th.clickable(scope='col' @click="setSorting('size')") Size
                +HeaderSortIcon()(:class="getSortingClass('size')")
              th.clickable(scope='col' @click="setSorting('transferred')") Transferred
                +HeaderSortIcon()(:class="getSortingClass('transferred')")
              th.clickable(v-if="!fromRpc" scope='col' @click="setSorting('rate')") Rate
                +HeaderSortIcon()(:class="getSortingClass('rate')")
              th.clickable(scope='col' @click="setSorting('ignored')" v-if='showIgnoredField') Ignored
                +HeaderSortIcon()(:class="getSortingClass('ignored')")
              th.clickable(scope='col' @click="setSorting('progress')") Progress
                +HeaderSortIcon()(:class="getSortingClass('progress')")
            tr
              th(colspan=2, scope="row") TOTAL
              th {{ totalSize | b-byteSize }}
              th {{ totalTransferred | b-byteSize }}
              th(v-if="!fromRpc") {{ totalRate | b-byteSize }}/s
              td(colspan=2)

          //- Header for Small Screen
          template(v-else)
            tr
              th.clickable(scope='col' colspan="2" @click="setSorting('index')") Index
                +HeaderSortIcon()(:class="getSortingClass('index')")
              th.clickable(scope='col' @click="setSorting('status')") Status
                +HeaderSortIcon()(:class="getSortingClass('status')")
              th.clickable(scope='col' @click="setSorting('progress')") Progress
                +HeaderSortIcon()(:class="getSortingClass('progress')")

        tbody
          // Data for Large Screens
          tr(:key='file.name' v-if="isScreenLG" v-for='file in files')
            th {{ file.name }}
            td {{ file.status }}
            td {{ file.size | b-byteSize }}
            td {{ file.transferred | b-byteSize }}
            td(v-if="!fromRpc")
              span(v-if="file.rate > 0") {{ file.rate | b-byteSize }}/s
              span(v-else) -
            td(v-if='showIgnoredField')
              BaseToggle(:inEdit="inEdit" :value="file.ignored"
                :disabled="!canIgnoreBeModified(file)"
                @userEdit="ignoreFileCmd(file, $event)")
            td
              ProgressBar(:progress="file.progress || 0" :fileStatus="file.status")

          // Data for Small Screens (strange behaviour with v-else)
          template(v-if="!isScreenLG" v-for='file in files')
            tr.clickable(:key='file.name' @click="toggleCollapseRow(file.index)")
              td
                i.fa.fa-caret-right(v-if="!toggleRowStore[file.index]")
                i.fa.fa-caret-down(v-else)
              td.x-rf-index {{ file.index }}
              td {{ file.status }}
              td {{ file.progress }}%
            BaseAnimationBlock(anim='fade')
              tr(:key='file.name + "-details"' v-if="toggleRowStore[file.index]")
                td(colspan="100")
                  .row.m-2.text-nowrap.text-left
                    .col-12.col-sm-6 #[strong File Size: ] {{ file.size | b-byteSize }}
                    .col-12.col-sm-6 #[strong Transferred: ] {{ file.transferred | b-byteSize }}
                    .col-12.col-sm-6
                      .row.align-items-left
                        .col-auto #[strong Ignored: ]
                        .col-auto
                          BaseToggle(:inEdit="inEdit" :value="file.ignored"
                            :disabled="!canIgnoreBeModified(file)"
                            @userEdit="ignoreFileCmd(file, $event)")
                    .col-12.col-sm-6(v-if="!fromRpc") #[strong Rate: ]{{ file.rate | b-byteSize }}
</template>
<script>
export { default } from "./RFMergerFilesView.vue.js";
</script>
<style scoped>
  .table-head > th {
    border: 1px solid #dee2e6 !important;
  }

  .table td, .table th {
    vertical-align: middle;
    text-align: center;
    font-size: 0.9rem;
  }

  .header-icon {
    float: right;
    margin-right: 0.5rem !important;
    margin-top: 0.25rem !important;
  }

  .i-deactivated {
    color: #888;
  }
</style>
